#ifndef AL_KLUDGE_TYPES_H
#define AL_KLUDGE_TYPES_H

#include "AL/altypes.h"

#define LOKI_ENUMERATION_BASE           0x500000
#define LOKI_ENUM(o, x)     (LOKI_ENUMERATION_BASE + ((o<<16) | x))

/*
 *  Channel operations are probably a big no-no and destined
 *  for obsolesence.
 */
#define AL_CHAN_BASE 0
#define	AL_CHAN_INVALID_LOKI   LOKI_ENUM(AL_CHAN_BASE, 0)
#define	AL_CHAN_MAIN_LOKI      LOKI_ENUM(AL_CHAN_BASE, 1)
#define	AL_CHAN_PCM_LOKI       LOKI_ENUM(AL_CHAN_BASE, 2)
#define	AL_CHAN_CD_LOKI        LOKI_ENUM(AL_CHAN_BASE, 3)

typedef struct WaveFMT {
        ALushort encoding;
	ALushort channels;               /* 1 = mono, 2 = stereo */
	ALuint frequency;              /* One of 11025, 22050, or 44100 Hz */
	ALuint byterate;               /* Average bytes per second */
	ALushort blockalign;             /* Bytes per sample block */
	ALushort bitspersample;
} alWaveFMT_LOKI;

typedef struct _MS_ADPCM_decodestate {
	ALubyte hPredictor;
	ALushort iDelta;
	ALshort iSamp1;
	ALshort iSamp2;
} alMSADPCM_decodestate_LOKI;

typedef struct MS_ADPCM_decoder {
	alWaveFMT_LOKI wavefmt;
	ALushort wSamplesPerBlock;
	ALushort wNumCoef;
	ALshort aCoeff[7][2];
	/* * * */
	alMSADPCM_decodestate_LOKI state[2];
} alMSADPCM_state_LOKI;

typedef struct IMA_ADPCM_decodestate_s {
	ALint valprev;	/* Previous output value */
	ALbyte index;		/* Index into stepsize table */
} alIMAADPCM_decodestate_LOKI;

typedef struct IMA_ADPCM_decoder {
	alWaveFMT_LOKI wavefmt;
	ALushort wSamplesPerBlock;
	/* * * */
	alIMAADPCM_decodestate_LOKI state[2];
} alIMAADPCM_state_LOKI;

#endif /* AL_KLUDGE_TYPES_H */
